#include <Wire.h>
#include <VL53L0X.h>
#include <ESP32Servo.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

const int touchsens = D10;
const int ventilador = D2;
const int motorPin1 = D0;  // Pin 9 connected to IN1 on the L298N
const int motorPin2 = D1; // Pin 10 connected to IN2 on the L298N
const int duration = 400;  // Duration to keep the pin HIGH in milliseconds

int pos = 0;    

VL53L0X sensor;
Servo myservo;  // create servo object to control a servo

const int myPos = 20;  // define the step size
const int maxPos = 160;   // maximum servo angle

#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
#define OLED_RESET     -1
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

int progress = 0; // progress of the progressbar

unsigned long previousMillis = 0;
const long interval = 4200; // Interval in milliseconds

void setup() {
  myservo.attach(D6);  // attaches the servo on pin 9 to the servo object
  myservo.write(pos);
  pinMode(touchsens,INPUT);
  pinMode(ventilador,OUTPUT);
  pinMode(motorPin1, OUTPUT);
  pinMode(motorPin2, OUTPUT);
  //sensor.setTimeout(500);
  //sensor.startContinuous(2000);
}

void loop() {
  //Start
  pos = maxPos;
  myservo.write(pos);
  display.clearDisplay();
  display.drawBitmap(0, 0, myBitmap, SCREEN_WIDTH, SCREEN_HEIGHT, SSD1306_WHITE);
  display.display();
  delay(2000);
  display.clearDisplay();
  // Set text size and color
  display.setTextSize(1);
  display.setTextColor(SSD1306_WHITE);
  // Display the text
  display.setCursor(0, 0); // Set cursor to top-left corner
  display.println("Hello!!!");
  display.println("Please put your");
  display.println("phone through");
  display.println("the wall");
  display.display();
  delay(3000);

  //PROCCESS AREA
  //int vals = sensor.readRangeContinuousMillimeters();
  delay(3000);
  int vals = 20;
  if (vals < 141){
    display.clearDisplay();
    // Set text size and color
    display.setTextSize(1);
    display.setTextColor(SSD1306_WHITE);
    // Display the text
    display.setCursor(0, 0); // Set cursor to top-left corner
    display.println("Now please");
    display.println("Spray the liquid");
    display.println("on the right side");
    display.display();
    int val = digitalRead(touchsens);
    while(val != HIGH){}
    digitalWrite(ventilador,HIGH);
    pos = myPos;
    myservo.write(pos);  // move the servo to the new position
    while(progress < 101) {
        unsigned long currentMillis = millis();
        if (currentMillis - previousMillis >= interval) {
            previousMillis = currentMillis;
            
            display.clearDisplay(); // Clear the display buffer
            display.drawRect(12, 21, 104, 20, WHITE);
            display.fillRect(14, 23, progress, 16, WHITE); // draw the progressbar fill
            display.setTextSize(1);
            display.setTextColor(WHITE);
            display.setCursor(33, 53);
            display.print(F("Progress: "));
            display.print(progress);
            display.print(F("%"));
            display.setTextSize(1);
            display.setTextColor(WHITE);
            display.setCursor(0, 7);
            display.println(F("Progress Bar Screen"));
            display.display(); // Display the content in the buffer
            
            progress++;
        }
    }
    //Finish
    progress = 0;
    digitalWrite(ventilador,LOW);
    val = LOW;
    pos = maxPos;
    myservo.write(pos);
    int vals2 = sensor.readRangeContinuousMillimeters();
    while(vals2<=vals){
      vals2 = sensor.readRangeContinuousMillimeters();
    }
  }
}
